*
* $VER: c2p8.s (22.11.96) 33.3
*
* - 8 bitplane c2p made by Mikael Kalms
* - modified by me to support BitMaps
*
* Version history:
*
* ?     ?           kalms
*
*       - original routine appeared at c.s.a.programmer
*
* 33.2  16.11.96    laukkanen
*
*       - modified a little
*
* 33.3  22.11.96    laukkanen
*
*       - separated from the source
*

    xdef    _c2p8


    include "exec/types.i"
    include "graphics/gfx.i"

; a0 - chunky start
; a1 - BitMap structure
; a2 - chunky end

_c2p8
    movem.l d2-d7/a2-a6,-(sp)

    suba.l  #4*8+4,sp

    move.l  (bm_Planes,a1),(sp)
    move.l  (bm_Planes+4,a1),(4,sp)
    move.l  (bm_Planes+8,a1),(8,sp)
    move.l  (bm_Planes+12,a1),(12,sp)
    move.l  (bm_Planes+16,a1),(16,sp)
    move.l  (bm_Planes+20,a1),(20,sp)
    move.l  (bm_Planes+24,a1),(24,sp)
    move.l  (bm_Planes+28,a1),(28,sp)

    move.l  a0,(32,sp)

    move.l  #$33333333,d5
    move.l  #$55555555,d6
    move.l  #$00ff00ff,a6

    move.l  (a0)+,d0                ; get first 16 pixels
    move.l  (a0)+,d2
    move.l  (a0)+,d1
    move.l  (a0)+,d3

    move.l  #$0f0f0f0f,d4           ; Merge 4x1, part 1
    and.l   d4,d0
    and.l   d4,d2
    lsl.l   #4,d0
    or.l    d2,d0

    and.l   d4,d1
    and.l   d4,d3
    lsl.l   #4,d1
    or.l    d3,d1

    move.l  d1,a3
    move.l  (a0)+,d2
    move.l  (a0)+,d1
    move.l  (a0)+,d3
    move.l  (a0)+,d7

    and.l   d4,d1			; Merge 4x1, part 2
    and.l   d4,d2
    lsl.l   #4,d2
    or.l    d1,d2
    and.l   d4,d3
    and.l   d4,d7
    lsl.l   #4,d3
    or.l    d7,d3

    move.l  a3,d1

    swap    d2			; Swap 16x2
    move.w  d0,d7
    move.w  d2,d0
    move.w  d7,d2
    swap    d2
    swap    d3
    move.w  d1,d7
    move.w  d3,d1
    move.w  d7,d3
    swap    d3

    bra.s   .start1
.x1
    move.l  (a0)+,d0
    move.l  (a0)+,d2
    move.l  (a0)+,d1
    move.l  (a0)+,d3

    move.l  (8,sp),a1
    move.l  d7,(-4,a1)                  ; bitplane 2

    move.l  #$0f0f0f0f,d4		; Merge 4x1, part 1
    and.l   d4,d0
    and.l   d4,d2
    lsl.l   #4,d0
    or.l    d2,d0

    and.l   d4,d1
    and.l   d4,d3
    lsl.l   #4,d1   
    or.l    d3,d1

    move.l  d1,a3
    
    move.l  (a0)+,d2
    move.l  (a0)+,d1
    move.l  (a0)+,d3
    move.l  (a0)+,d7

    move.l  (4,sp),a1
    move.l  a4,(-4,a1)                  ; bitplane 1

    and.l   d4,d1			; Merge 4x1, part 2
    and.l   d4,d2
    lsl.l   #4,d2
    or.l    d1,d2

    and.l   d4,d3
    and.l   d4,d7
    lsl.l   #4,d3
    or.l    d7,d3

    move.l  a3,d1

    swap    d2			        ; Swap 16x2
    move.w  d0,d7
    move.w  d2,d0
    move.w  d7,d2
    swap    d2

    swap    d3
    move.w  d1,d7
    move.w  d3,d1
    move.w  d7,d3
    swap    d3

    move.l  (sp),a1
    move.l  a5,(-4,a1)                  ; bitplane 0

.start1
    move.l  a6,d4
    
    move.l  d2,d7			; Swap 2x2
    lsr.l   #2,d7
    eor.l   d0,d7
    and.l   d5,d7
    eor.l   d7,d0
    lsl.l   #2,d7
    eor.l   d7,d2

    move.l  d3,d7
    lsr.l   #2,d7
    eor.l   d1,d7
    and.l   d5,d7
    eor.l   d7,d1
    lsl.l   #2,d7
    eor.l   d7,d3

    move.l  d1,d7
    lsr.l   #8,d7
    eor.l   d0,d7
    and.l   d4,d7
    eor.l   d7,d0
    lsl.l   #8,d7
    eor.l   d7,d1
    
    move.l  d1,d7
    lsr.l   #1,d7
    eor.l   d0,d7
    and.l   d6,d7
    eor.l   d7,d0

    move.l  (12,sp),a1
    move.l  d0,(a1)                     ; bitplane 3

    addq.l  #4,(sp)                     ; add bitplane pointers
    addq.l  #4,(4,sp)
    addq.l  #4,(8,sp)
    addq.l  #4,(12,sp)

    add.l   d7,d7
    eor.l   d1,d7

    move.l  d3,d1
    lsr.l   #8,d1
    eor.l   d2,d1
    and.l   d4,d1
    eor.l   d1,d2
    lsl.l   #8,d1
    eor.l   d1,d3

    move.l  d3,d1
    lsr.l   #1,d1
    eor.l   d2,d1
    and.l   d6,d1
    eor.l   d1,d2
    add.l   d1,d1
    eor.l   d1,d3

    move.l  d2,a4
    move.l  d3,a5

    cmpa.l  a0,a2
    bne	.x1

    move.l  (8,sp),a1
    move.l  d7,(-4,a1)           ; bitplane 2

    move.l  (4,sp),a1
    move.l  a4,(-4,a1)           ; bitplane 1

    move.l  (sp),a1              ; bitplane 0
    move.l  a5,(-4,a1)

    move.l  (32,sp),a0           ; chunky address

    move.l  (a0)+,d0
    move.l  (a0)+,d2
    move.l  (a0)+,d1
    move.l  (a0)+,d3

    move.l  #$f0f0f0f0,d4		; Merge 4x1, part 1
    and.l   d4,d0
    and.l   d4,d2
    lsr.l   #4,d2
    or.l    d2,d0

    and.l   d4,d1
    and.l   d4,d3
    lsr.l   #4,d3
    or.l    d3,d1
    move.l  d1,a3

    move.l  (a0)+,d2
    move.l  (a0)+,d1
    move.l  (a0)+,d3
    move.l  (a0)+,d7

    and.l   d4,d1			; Merge 4x1, part 2
    and.l   d4,d2
    lsr.l   #4,d1
    or.l    d1,d2

    and.l   d4,d3
    and.l   d4,d7
    lsr.l   #4,d7
    or.l    d7,d3

    move.l  a3,d1

    swap    d2			; Swap 16x2
    move.w  d0,d7
    move.w  d2,d0
    move.w  d7,d2
    swap    d2

    swap    d3
    move.w  d1,d7
    move.w  d3,d1
    move.w  d7,d3
    swap    d3

    bra.s   .start2
.x2
    move.l  (a0)+,d0
    move.l  (a0)+,d2
    move.l  (a0)+,d1
    move.l  (a0)+,d3

    move.l  (24,sp),a1
    move.l  d7,(-4,a1)                     ; bitplane 6

    move.l  #$f0f0f0f0,d4		; Merge 4x1, part 1
    and.l   d4,d0
    and.l   d4,d2
    lsr.l   #4,d2
    or.l    d2,d0

    and.l   d4,d1
    and.l   d4,d3
    lsr.l   #4,d3
    or.l    d3,d1

    move.l  d1,a3

    move.l  (a0)+,d2
    move.l  (a0)+,d1
    move.l  (a0)+,d3
    move.l  (a0)+,d7

    move.l  (20,sp),a1
    move.l  a4,(-4,a1)                     ; bitplane 5

    and.l   d4,d1			; Merge 4x1, part 2
    and.l   d4,d2
    lsr.l   #4,d1
    or.l    d1,d2

    and.l   d4,d3
    and.l   d4,d7
    lsr.l   #4,d7
    or.l    d7,d3

    move.l  a3,d1

    swap    d2			; Swap 16x2
    move.w  d0,d7
    move.w  d2,d0
    move.w  d7,d2
    swap    d2

    swap    d3
    move.w  d1,d7
    move.w  d3,d1
    move.w  d7,d3
    swap    d3

    move.l  (16,sp),a1
    move.l  a5,(-4,a1)                  ; bitplane 4

.start2
    move.l  a6,d4
    move.l  d2,d7			; Swap 2x2
    lsr.l   #2,d7
    eor.l   d0,d7
    and.l   d5,d7
    eor.l   d7,d0
    lsl.l   #2,d7
    eor.l   d7,d2

    move.l  d3,d7
    lsr.l   #2,d7
    eor.l   d1,d7
    and.l   d5,d7
    eor.l   d7,d1
    lsl.l   #2,d7
    eor.l   d7,d3

    move.l  d1,d7
    lsr.l   #8,d7
    eor.l   d0,d7
    and.l   d4,d7
    eor.l   d7,d0
    lsl.l   #8,d7
    eor.l   d7,d1

    move.l  d1,d7
    lsr.l   #1,d7
    eor.l   d0,d7
    and.l   d6,d7
    eor.l   d7,d0

    move.l  (28,sp),a1
    move.l  d0,(a1)                     ; bitplane 7

    addq.l  #4,(16,sp)                  ; add bitplane pointers
    addq.l  #4,(20,sp)
    addq.l  #4,(24,sp)
    addq.l  #4,(28,sp)

    add.l   d7,d7
    eor.l   d1,d7

    move.l  d3,d1
    lsr.l   #8,d1
    eor.l   d2,d1
    and.l   d4,d1
    eor.l   d1,d2
    lsl.l   #8,d1
    eor.l   d1,d3

    move.l  d3,d1
    lsr.l   #1,d1
    eor.l   d2,d1
    and.l   d6,d1
    eor.l   d1,d2
    add.l   d1,d1
    eor.l   d1,d3

    move.l  d2,a4
    move.l  d3,a5

    cmpa.l  a0,a2
    bne	.x2

    move.l  (24,sp),a1              ; bitplane 6
    move.l  d7,(-4,a1)
    move.l  (20,sp),a1              ; bitplane 5
    move.l  a4,(-4,a1)
    move.l  (16,sp),a1              ; bitplane 4
    move.l  a5,(-4,a1)

    movem.l (sp)+,d2-d7/a2-a6

    rts
